﻿local GarrisonDone = ...

if (not GarrisonDone_Varsb) then GarrisonDone_Varsb = {} end

if (not GarrisonDoneBuildFrame) then GarrisonDoneBuildFrame = GarrisonDoneBuildFrame end


local character = UnitName("player").."-"..GetRealmName();


 
function GarrisonDone_Buildings(self, event, ...)
        if ( event == "GARRISON_LANDINGPAGE_SHIPMENTS" ) then
            GarrisonDone_UpdateShipData(data)
        elseif ( event == "GARRISON_SHIPMENT_RECEIVED" ) then
            GarrisonDone_UpdateShipData(data)
    end
end

function GarrisonDoneBuildScrollFrame_OnShow(self)
        if GarrisonDoneBuildScrollFrame:IsShown() then
        C_Garrison.RequestLandingPageShipmentInfo();
        GarrisonDone_UpdateShipData(data);
    end
end

        -- use a different system for seconds than Alts use, so no conflict --
function GarrisonDone_SecondsToStrTime(seconds)
	local originalSeconds = seconds;
	-- Seconds In Min, Hour, Day
    local secondsMinute = 60;
    local secondsHour  = 60 * secondsInAMinute;
    local secondsDay    = 24 * secondsInAnHour;
    -- Days
    local days = math.floor( seconds / secondsDay );
    -- Hours
    local hourSeconds = seconds % secondsDay;
    local hours = math.floor( hourSeconds / secondsHour );
    -- Minutes
    local minuteSeconds = hourSeconds % secondsHour;
    local minutes = floor( minuteSeconds / secondsMinute );
    -- Seconds
    local remainingSeconds = minuteSeconds % secondsMinute;
    local seconds = math.ceil( remainingSeconds );
	--
	local strTime = (days > 0 and hours == 0 and days .. " day") or (days > 0 and days .. " day " .. hours .. " hr") or (hours > 0 and minutes == 0 and hours .. " hr") or (hours > 0 and hours .. " hr " .. minutes .. " min") or (minutes > 0 and minutes .. " min") or seconds .. " sec";
end

        -- convert the str back to seconds so we can count --
function GarrisonDone_StrTimeToSeconds(str)
	if not str then return 0; end
	local M = function( i )
		if i == "hr" then
			return 3600;
		elseif i == "min" then
			return 60;
		elseif i == "sec" then
			return 1;
		end
	end
	local t1, i1, t2, i2 = strsplit( " ", str ); -- x hr y min or x hr or x min or x sec --
	return t1 * M( i1 ) + ( t2 and t2 * M( i2 ) or 0 );
end


        -- Set Buldings and Shipment Data, ?? why isnt this updating each time --
function GarrisonDone_UpdateShipData(data)
        GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] = {};
	    for _, building, v in ipairs( C_Garrison.GetBuildings() ) do
		local buildingID, buildingName, _, _, _, rank, _, _, _, _, _, _, _, _, _, _, _, _, _, _, isBeingBuilt, _, _, _, _ = C_Garrison.GetOwnedBuildingInfo( building.plotID );
		local name, _, shipmentCapacity, shipmentsReady, shipmentsTotal, _, duration, timeleftString, itemName, _, _, _ = C_Garrison.GetLandingPageShipmentInfo(buildingID);
        if shipmentCapacity then
			table.insert(GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")],
            { 
            ["buildingID"] = buildingID,
            ["idName"] = buildingName,
                ["bname"] = name,
                ["item"] = itemName,
				["capacity"] = shipmentCapacity,
				["ready"] = tonumber(shipmentsReady),
				["total"] = tonumber(shipmentsTotal),
				["duration"] = duration,
				["lastUpdate"] = time(),
                ["inprog"] = 0,
                ["shipmentsToSeconds"] = GarrisonDone_StrTimeToSeconds(timeleftString),
                ["class"] = UnitClass("player"),
                ["character"] = GetUnitName("player"),
                ["realm"] = GetRealmName()
			});
            
        end
    end
end


 
 
        -- set locals for scroll frame --
local maxsBars = 7
local barsList = {}
local unUsedsBars = {}
local totalsBars = 0
local tempSortedList = {}
local sortsOrders = {
		{name = "Default", value = "default"},
        }
    
        -- rotate the bar frames so we dont waste resources --
function GarrisonDone_ShipRebuild()
	local template = "GarrisonDones_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barsList) do
		if string.find("GarrisonDones_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedsBars[#unUsedsBars + 1] = object
			object.bars:Hide()
			barsList[index] = nil
		end
	end
	GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] = {}
	    GarrisonDone_UpdateShipData(data)
end
 
 
 
 
        -- Load the Bars that will make up the list --
function GarrisonDoneBuildFrame_OnLoad(self)
	for l = 1, maxsBars, 1 do
		    bars = CreateFrame("StatusBar", "GarrisonDones_bars_"..l, GarrisonDoneBuildScrollFrame)
		    bars:SetWidth(180)
		    bars:SetHeight(35)
		    bars:SetOrientation("HORIZONTAL")
            local backdrop = {
                bgFile = "Interface\AddOns\GarrisonDone\images\StatusBar7",  
                edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
                tile = false,
                edgeSize = 6,
                insets = {
                    left = 1,
                    right = 1,
                    top = 1,
                    bottom = 1
                }
            }
            bars:SetBackdrop(backdrop)
            bars:Raise()
            bars:SetBackdropColor(0, 0, 0, 0.4)
		    MGDbLabel = bars:CreateFontString("GarrisonDones_labels_"..l, "ARTWORK", "GameFontNormalMed2")
		    MGDbLabel:SetTextHeight(12)
		    MGDbLabel:SetTextColor(230, 204, 128, 10)
		    MGDbLabel:SetPoint("LEFT", 0, 0, bars)
		    MGDbLabel:SetPoint("RIGHT", bars)
		    MGDbLabel:SetJustifyH("LEFT")
		    MGDbLabel:SetNonSpaceWrap(false)
		    bars:SetPoint("TOPLEFT", "GarrisonDoneBuildScrollFrame", 13, 36-38*(l))
		    bars:SetPoint("RIGHT", "GarrisonDoneBuildScrollFrame", 0, 0)
	end
end

C_Timer.After(40, function() GarrisonDone_Buildings() end)

-- We have the Data now update the frame to show it - can we add a blank frame between names ?? --
function GarrisonDoneBuildFrame_OnUpdate(self, elapsed)
        if GarrisonDoneBuildFrame:IsShown() == true then
            GarrisonDoneBuildPageName:SetText("BUILDINGS");
			local l = 0
			local d = 0
               if GarrisonDone_Varsb then
					for realm, v1 in pairs(GarrisonDone_Varsb) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								l = l + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneBuildScrollFrame)
								if l > offset and l <= (offset + maxsBars) then
									d = d + 1
                                    local bname = data.bname
								--	local t = data.endTime - time()
									local buildingID = data.buildingID
									local bars, texture, label, MGDbLabel, MGDbLabel1, object
									bars = _G["GarrisonDones_bars_"..d]
									MGDbLabel = _G["GarrisonDones_labels_"..d]
                                    
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    MGDbLabel:SetPoint("LEFT", 10, 0, bars)
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                    end
                                        -- Shorten the Mines for Alliance --
                                    if data.idName == "Lunarfall Excavation" then data.idName = "Excavation" end
                                        -- Give Ready and Total a number in case there are none in progress --
                                    if data.ready == nil then data.ready = 0 end
                                    if data.total == nil then data.total = 0 end
                                    local inprog = (data.total - data.ready) -- Count down In progress --
                                    
                                    
                                        -- Set Labels --
                                    if data.total > 0 then
									MGDbLabel:SetText(string.format(color..character.." - "..realm.."|r  -  |cffE6CC80"..data.idName:sub(1,12).."  |cff1eff00"..data.ready.."|cffffffff/|cfffeef02"..inprog.."|cffffffff/|cffe6cc80"..data.capacity..""))
                                	end
                                    
                                    if data.total == 0 then
									MGDbLabel:SetText(string.format(color..character.." - |r|cffE6CC80"..data.idName:sub(1,12).."                      -|cffFFFC00 Out to Lunch|r -"))
                                    -- show the Bars --
									bars:Show()
                                    end
                                end								
							end 
						end
					end  
			    FauxScrollFrame_Update(GarrisonDoneBuildScrollFrame, l, maxsBars, 15)
			    if d <= maxsBars then
				    d = d + 1
				for n = d, maxsBars do
					_G["GarrisonDones_bars_"..n]:Hide()
				    end
			    end
		    end
            if GarrisonDoneBuildFrame:IsShown() == true then
		        GarrisonDoneBuildScrollFrame:Show()
                GarrisonDone_UpdateShipData(data);
	        else
		        GarrisonDoneBuildFrame:Hide()
                GarrisonDoneBuildScrollFrame:Hide()
            end
        end
--	end 
end

        -- old Update the Scroll Bar --
function GarrisonDoneBuildFrame_ScrollBar_Update()
	       -- GarrisonDoneAltsFrame_OnUpdate(nil, 2) -- this was changed and now updates at 212 -- 
end
 

function GarrisonDoneBuildSort_OnLoad()
	        for l = 1, #sortsOrders do
		    info = {
			    text = sortsOrders[l].name;
			    value = sortsOrders[l].value;
		    }
	end
end 
 
 